package xyz.tbvns.Models;

import com.badlogic.gdx.graphics.*;
import com.badlogic.gdx.graphics.g3d.Material;
import com.badlogic.gdx.graphics.g3d.Model;
import com.badlogic.gdx.graphics.g3d.attributes.ColorAttribute;
import com.badlogic.gdx.graphics.g3d.utils.MeshPartBuilder;
import com.badlogic.gdx.graphics.g3d.utils.ModelBuilder;
import com.badlogic.gdx.math.Vector3;
import lombok.AllArgsConstructor;
import lombok.Data;
import xyz.tbvns.ui.Renderable;

import java.util.ArrayList;
import java.util.List;

@Data
@AllArgsConstructor
public class GDModel implements Renderable {
    private ArrayList<Face> faces;
    private String name;

    public Model toModel() {
        ModelBuilder builder = new ModelBuilder();
        builder.begin();
        List<Mesh> meshes = new ArrayList<>();
        for (Face face : faces) {
            MeshPartBuilder meshBuilder = builder.part(
                    "whytfdoineedthis",
                    GL20.GL_TRIANGLES,
                    VertexAttributes.Usage.Position | VertexAttributes.Usage.Normal,
                    new Material(
                            ColorAttribute.createDiffuse(
                                    face.color.getRed(),
                                    face.color.getGreen(),
                                    face.color.getBlue(),
                                    face.color.getAlpha()
                            )
                    )
            );
            if (face.Has4Point) {
                meshBuilder.rect(
                        face.points.get(0).x, face.points.get(0).y, face.points.get(0).z,
                        face.points.get(1).x, face.points.get(1).y, face.points.get(1).z,
                        face.points.get(2).x, face.points.get(2).y, face.points.get(2).z,
                        face.points.get(3).x, face.points.get(3).y, face.points.get(3).z,
                        0, 0, 0
                );

            } else {
                meshBuilder.setColor(face.color.getRed(), face.color.getGreen(), face.color.getBlue(), face.color.getAlpha());
                meshBuilder.triangle(
                        new Vector3(face.points.get(0).x, face.points.get(0).y, face.points.get(0).z),
                        Color.BLACK,
                        new Vector3(face.points.get(1).x, face.points.get(1).y, face.points.get(1).z),
                        Color.BLACK,
                        new Vector3(face.points.get(2).x, face.points.get(2).y, face.points.get(2).z),
                        Color.BLACK
                );
            }
        }
        return builder.end();
    }
}
