package xyz.tbvns.ui.Elements;

import com.badlogic.gdx.Gdx;
import imgui.ImGui;
import imgui.flag.ImGuiWindowFlags;
import jnafilechooser.api.JnaFileChooser;
import xyz.tbvns.Editor.ModelsManager;
import xyz.tbvns.Models.Animation;
import xyz.tbvns.Models.GDModel;
import xyz.tbvns.ui.Element;
import xyz.tbvns.ui.Renderable;

import java.awt.*;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;

public class ModelsList implements Element {
    @Override
    public void render() {
        ImGui.begin("Menu", ImGuiWindowFlags.NoDecoration | ImGuiWindowFlags.NoMove);
        ImGui.setWindowSize(200, Gdx.graphics.getHeight() - 19 - 200);
        ImGui.setWindowPos(0, 19);

        ImGui.beginTabBar("modelbar");
        modelsTab();
        ImGui.endTabBar();


        ImGui.end();
    }

    public void modelsTab() {
        ImGui.beginTabItem("Models");
        loadButton();
        modelsButtons();
        ImGui.endTabItem();
    }

    public void loadButton() {
        if (ImGui.button("Load a model")) {
            JnaFileChooser fileChooser = new JnaFileChooser();
            fileChooser.setMode(JnaFileChooser.Mode.Directories);
            if (fileChooser.showOpenDialog((Window) null)) {
                try {
                    ModelsManager.addAnimated(fileChooser.getSelectedFile());
                } catch (FileNotFoundException e) {
                    throw new RuntimeException(e);
                }
            }
        }
    }

    public void modelsButtons() {
        List<Renderable> renderables = new ArrayList<>();
        for (GDModel model : ModelsManager.models) {
            renderables.add(model);
        }
        for (Animation animation : ModelsManager.animations) {
            renderables.add(animation);
        }
        ImGui.text("Available models:");
        for (Renderable renderable : renderables) {
            renderable.render();
        }
    }
}
